﻿using Plane.Copters;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Plane.FormationCreator.Formation
{
    public partial class FlightTaskSingleCopterInfo
    {
        public static FlightTaskSingleCopterInfo CreateForFlyToTask(ICopter copter, double targetLat, double targetLng, float targetAlt)
        {
            var info = new FlightTaskSingleCopterInfo(copter)
            {
                TargetLat = targetLat,
                TargetLng = targetLng,
                TargetAlt = targetAlt
            };
            return info;
        }

        public static FlightTaskSingleCopterInfo CreateForFlyToTask(ICopter copter, LatLng latLngOffset, float targetAlt)
        {
            var info = new FlightTaskSingleCopterInfo(copter)
            {
                LatLngOffset = latLngOffset,
                TargetAlt = targetAlt
            };
            return info;
        }
    }
}
