﻿using Plane.Collections;
using Plane.Copters;
using Plane.FormationCreator.Formation;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.CommandWpf;
using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace Plane.FormationCreator.ViewModels
{
    public class ModifyTaskViewModel : ViewModelBase
    {
        public ModifyTaskViewModel(FlightTaskManager flightTaskManager)
        {
            _flightTaskManager = flightTaskManager;
            //_flightTaskManager.SingleCopterInfoChanged += (sender, e) =>
            //{
            //    var changedSingleInfo = e.ChangedSingleCopterInfo;
            //    if (changedSingleInfo.Copter == _copterManager.SelectedCopters.FirstOrDefault())
            //    {
            //        if (changedSingleInfo is FlyToFlightTaskSingleCopterInfo)
            //        {
            //            FlyToLat = changedSingleInfo.TargetLat;
            //            FlyToLng = changedSingleInfo.TargetLng;
            //            FlyToAlt = changedSingleInfo.TargetAlt;
            //        }
            //    }
            //};
            // TODO: 林俊清, 20150803, 没什么问题就把这段以及 FlyToLat 等属性删了。
            //_flightTaskManager.PropertyChanged += (sender, e) =>
            //{
            //    switch (e.PropertyName)
            //    {
            //        case nameof(FlightTaskManager.SelectedTask):
            //            var currentCopter = _copterManager.SelectedCopters.FirstOrDefault();
            //            if (currentCopter != null)
            //            {
            //                var selectedTask = _flightTaskManager.SelectedTask;
            //                if (selectedTask != null)
            //                {
            //                    var singleCopterInfo = selectedTask.SingleCopterInfos.Find(i => i.Copter == currentCopter);
            //                    if (singleCopterInfo is FlyToFlightTaskSingleCopterInfo)
            //                    {
            //                        var info = singleCopterInfo as FlyToFlightTaskSingleCopterInfo;
            //                        this.FlyToLat = info.TargetLat;
            //                        this.FlyToLng = info.TargetLng;
            //                        this.FlyToAlt = info.TargetAlt;
            //                    }
            //                }
            //            }
            //            break;
            //        default:
            //            break;
            //    }
            //};
            //_copterManager.SelectedCoptersChanged += (sender, e) =>
            //{
            //    // TODO: 林俊清, 20150731, 处理多选飞行器时的情况。
            //    var selectedCopters = _copterManager.SelectedCopters;
            //    if (selectedCopters.Count() > 1)
            //    {
            //        CanModifySingleCopterInfo = false;
            //        return;
            //    }

            //    CanModifySingleCopterInfo = true;

            //    var currentCopter = e.AddedCopters.FirstOrDefault();
            //    if (currentCopter != null)
            //    {
            //        var selectedTask = _flightTaskManager.SelectedTask;
            //        if (selectedTask != null)
            //        {
            //            var singleCopterInfo = selectedTask.SingleCopterInfos.Find(i => i.Copter == currentCopter);
            //            if (singleCopterInfo is FlyToFlightTaskSingleCopterInfo)
            //            {
            //                var info = singleCopterInfo as FlyToFlightTaskSingleCopterInfo;
            //                this.FlyToLat = info.TargetLat;
            //                this.FlyToLng = info.TargetLng;
            //                this.FlyToAlt = info.TargetAlt;
            //            }
            //        }
            //    }
            //};
            //this.PropertyChanged += (sender, e) =>
            //{
            //    switch (e.PropertyName)
            //    {
            //        case nameof(FlyToLat):
            //            InvokeForSelectedSingleCopterInfos(info => info.TargetLat = FlyToLat);
            //            break;
            //        case nameof(FlyToLng):
            //            InvokeForSelectedSingleCopterInfos(info => info.TargetLng = FlyToLng);
            //            break;
            //        case nameof(FlyToAlt):
            //            InvokeForSelectedSingleCopterInfos(info => info.TargetAlt = FlyToAlt);
            //            break;
            //        case nameof(StaggerRoutes):
            //            {
            //                var modifyingTask = _flightTaskManager.SelectedTask as FlyToFlightTask;
            //                if (modifyingTask != null)
            //                {
            //                    modifyingTask.StaggerAlt = this.StaggerRoutes;
            //                }
            //            }
            //            break;
            //        default:
            //            break;
            //    }
            //};
        }

        private FlightTaskManager _flightTaskManager;
        public FlightTaskManager FlightTaskManager { get { return _flightTaskManager; } }
        //private void InvokeForSelectedSingleCopterInfos(Action<FlightTaskSingleCopterInfo> action)
        //{
        //    var modifyingTask = _flightTaskManager.SelectedTask as FlyToFlightTask;
        //    if (modifyingTask != null && _copterManager.SelectedCopters.Count() == 1)   // 林俊清, 20150731, 目前不处理多选的情况。
        //    {
        //        modifyingTask.FlyToFlightTaskSingleCopterInfos
        //        .Where(i => _copterManager.SelectedCopters.FirstOrDefault() == i.Copter)
        //        .ForEach(action);

        //        // TODO: 林俊清, 20150731, 添加同时改多个 SingleCopterInfo 的程序。
        //        //.Where(i => _copterManager.SelectedCopters.Contains(i.Copter))
        //    }
        //}

        private bool _CanModifySingleCopterInfo = true;
        public bool CanModifySingleCopterInfo
        {
            get { return _CanModifySingleCopterInfo; }
            set { Set(nameof(CanModifySingleCopterInfo), ref _CanModifySingleCopterInfo, value); }
        }

        private double _FlyToLat;
        public double FlyToLat
        {
            get { return _FlyToLat; }
            set { Set(nameof(FlyToLat), ref _FlyToLat, value); }
        }

        private double _FlyToLng;
        public double FlyToLng
        {
            get { return _FlyToLng; }
            set { Set(nameof(FlyToLng), ref _FlyToLng, value); }
        }

        private float _FlyToAlt;
        public float FlyToAlt
        {
            get { return _FlyToAlt; }
            set { Set(nameof(FlyToAlt), ref _FlyToAlt, value); }
        }

        private bool _StaggerRoutes;
        public bool StaggerRoutes
        {
            get { return _StaggerRoutes; }
            set { Set(nameof(StaggerRoutes), ref _StaggerRoutes, value); }
        }

        private ICommand _ExportTasksCommand;
        public ICommand ExportTasksCommand
        {
            get
            {
                return _ExportTasksCommand ?? (_ExportTasksCommand = new RelayCommand(() =>
                {
                    var exportedText = _flightTaskManager.ExportTasks();
                    var dialog = new SaveFileDialog
                    {
                        DefaultExt = "fcg",
                        Filter = "编队飞行任务 (*.fcg)|*.fcg"
                    };
                    if (dialog.ShowDialog() == true)
                    {
                        File.WriteAllText(dialog.FileName, exportedText);
                    }
                }));
            }
        }

        private ICommand _ImportTasksCommand;
        public ICommand ImportTasksCommand
        {
            get
            {
                return _ImportTasksCommand ?? (_ImportTasksCommand = new RelayCommand(() =>
                {
                    var dialog = new OpenFileDialog
                    {
                        DefaultExt = "fcg",
                        Filter = "编队飞行任务 (*.fcg)|*.fcg"
                    };
                    if (dialog.ShowDialog() == true)
                    {
                        var tasksText = File.ReadAllText(dialog.FileName);
                        _flightTaskManager.ImportTasks(tasksText);
                    }
                }));
            }
        }
    }
}
